package multisab.processing.ecgAnalysis.ecgFiducialPointsDetection;

import multisab.processing.ecgAnalysis.ecgFiducialPointsDetection.ptDetection.MartinezPT;
import multisab.processing.ecgAnalysis.ecgFiducialPointsDetection.qrsDetection.Elgendi;


/**
 * This class implements Elgendi QRS detection and Martinez PT detection algorithms.
 *
 * @author Davor Kukolja
 */

// TODO: Izbrisati, bila potrebna samo za MATLAB

public class FiducialPointsDetection {

    public static ecgFiducialPoints detectFiducialPoints(double[] ecg, double frequency) {
        int[] RPeaks;
        ecgFiducialPoints FiducialPoints;

        RPeaks = Elgendi.DetectRWave(ecg,frequency);
        FiducialPoints = MartinezPT.DetectFiducialPoints(ecg,frequency,RPeaks);

        return FiducialPoints;
    }

}